/**
 * Copyright (c) 2015-2016, IncQuery Labs Ltd. and Ericsson AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Abel Hegedus, Daniel Segesdi, Robert Doczi, Zoltan Ujhelyi - initial API and implementation
 */
package org.eclipse.viatra.integration.evm.jdt;

import org.eclipse.viatra.integration.evm.jdt.JDTActivationState;
import org.eclipse.viatra.integration.evm.jdt.JDTEventType;
import org.eclipse.viatra.transformation.evm.api.event.EventType;
import org.eclipse.viatra.transformation.evm.specific.lifecycle.UnmodifiableActivationLifeCycle;

@SuppressWarnings("all")
public class JDTActivationLifeCycle extends UnmodifiableActivationLifeCycle {
  public JDTActivationLifeCycle() {
    super(JDTActivationState.INACTIVE);
    this.internalAddStateTransition(JDTActivationState.INACTIVE, JDTEventType.APPEARED, JDTActivationState.APPEARED);
    this.internalAddStateTransition(JDTActivationState.APPEARED, JDTEventType.DISAPPEARED, JDTActivationState.INACTIVE);
    this.internalAddStateTransition(JDTActivationState.APPEARED, EventType.RuleEngineEventType.FIRE, JDTActivationState.FIRED);
    this.internalAddStateTransition(JDTActivationState.FIRED, JDTEventType.UPDATED, JDTActivationState.UPDATED);
    this.internalAddStateTransition(JDTActivationState.FIRED, JDTEventType.DISAPPEARED, JDTActivationState.DISAPPEARED);
    this.internalAddStateTransition(JDTActivationState.UPDATED, EventType.RuleEngineEventType.FIRE, JDTActivationState.FIRED);
    this.internalAddStateTransition(JDTActivationState.UPDATED, JDTEventType.DISAPPEARED, JDTActivationState.DISAPPEARED);
    this.internalAddStateTransition(JDTActivationState.DISAPPEARED, JDTEventType.APPEARED, JDTActivationState.UPDATED);
    this.internalAddStateTransition(JDTActivationState.DISAPPEARED, EventType.RuleEngineEventType.FIRE, JDTActivationState.INACTIVE);
  }
}
